fl

{
LED_bar     

PropForth 5.5 

 -- Curcuit for demo1, demo2, demo3, --  
           -------------
 P0  | LED_n LED_p | 220ohm--- GND
 P1  |             | 220ohm| 
 P2  |             | 220ohm| 
 P3  |             | 220ohm| 
 P4  |             | 220ohm| 
 P5  |             | 220ohm| 
 P6  |             | 220ohm| 
 P7  |             | 220ohm| 
 P8  |             | 220ohm| 
 P9  | MT123010AR  | 220ohm| 
 P10 |             | 220ohm| 
 P11 |             | 220ohm|
           -------------
           -------------
 P12 | LED_n LED_p | 220ohm--- GND
 P13 |             | 220ohm| 
 P14 |             | 220ohm| 
 P15 |             | 220ohm| 
 P16 |             | 220ohm| 
 P17 |             | 220ohm| 
 P18 |             | 220ohm| 
 P19 |             | 220ohm| 
 P20 |             | 220ohm| 
 P21 | MT123010AR  | 220ohm| 
 P22 |             | 220ohm| 
 P23 |             | 220ohm| 
           -------------
            
2013/10/19 16:23:45
}



\ a cog special register
[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]


\ *******************
\  Constants
\ *******************
0 constant pwm
pwm >m constant pwmm
clkfreq d1000 u/ constant 1msec         
clkfreq d40 u/ constant 25msec

\ Brightness for LED_bar element
 variable scale -4 allot d5 c, d10 c, d16 c, d23 c, d30 c, d37 c, d46 c, d64 c, 
 d46 c, d37 c, d30 c, d23 c, d16 c, d10 c, 

\ *******************
\  Variables
\ *******************
variable dT
\ variable cycle
\ wvariable flag
variable LED_level d20 allot

\ *******************
\   LED_bar
\ *******************

\ Drive LED-bar(24elements)   PWM/NCO single-ended mode
\ ( n1 -- )  n1:first pin of LED group
: single_drive_LED_bar
1msec d64 u/ dT L!

1 frqa COG!
\ Set P(pwm)-P(pwm+23) to output
pwm d24 0 do dup pinout 1+ loop drop
cnt COG@ 1msec +
swap          
begin
     \ Run 24-element
     d24 0 do
          i LED_level + C@                   \ Get level for target LED
          dT L@ u* 
          negate phsa COG!

          dup i + h10000000 or               \ Set APIN and CTRMODE
          ctra COG!                          \ PWM/NCO single-ended mode    
          swap
          1msec waitcnt                      \ Wait until cnt+1msec
          swap
          0 ctra COG!                        \ Reset counter
     loop
\ 0 until
fkey? swap drop until
2drop
;

\ Display test pattern1 for LED_bar by using PWM/NCO single-ended mode
\ ( -- )
: demo1
LED_level scale    
3 0 do
     8 0 do 2dup i + C@ swap i + C! loop 
     swap 8 + swap
loop
2drop
LED_level d24 dump
c" pwm single_drive_LED_bar" 0 cogx
begin fkey? swap drop until
0 cogreset                                                       
;

\ Display test pattern2 for LED_bar by using PWM/NCO single-ended mode
\ ( -- )
: demo2
LED_level scale
d14 0 do 
     2dup 
     C@ swap C!
     1+ swap 1+ swap
loop
drop scale
8 0 do 2dup i + C@ swap i + C! loop 
2drop
LED_level d24 dump
c" pwm single_drive_LED_bar" 0 cogx
begin fkey? swap drop until
0 cogreset
;

\ Display like_a_wave on LED_bar by using PWM/NCO single-ended mode
\ ( -- )
: demo3
c" pwm single_drive_LED_bar" 0 cogx
LED_level scale
cnt COG@ 25msec + rot2                            \ ( cnt LED_level scale )
begin 
     2dup
     d24 0 do
          2dup 
          C@ swap C!                              \ Store brightness data to LED_level array
          1+ dup scale d14 + = 
          if drop scale then                      \ scale table end?
          swap 
          1+ dup LED_level d24 + = 
          if drop LED_level then                  \ LED_level array end?
          swap
     loop
     2drop
     1+ dup scale d14 + = if drop scale then 
     rot                                          \ ( LED_level scale cnt ) 
     25msec waitcnt
     rot2                    
\     LED_level d24 dump
     fkey? swap drop
until
3drop
0 cogreset
;



\ Drive LED-bar(24elements)   PWM/NCO differential mode
\ Using BPIN
\ ( n1 -- )  n1:first pin of LED group
: dif_drive_LED_bar
1msec d64 u/ dT L!

1 frqa COG!
\ Set P(pwm)-P(pwm+23) to output
pwm d24 0 do dup pinout  1+ loop drop
cnt COG@ 1msec +
swap          
begin
     \ Run 24-element
     d24 0 do
          dup 
          i + 9 lshift                       \ Set BPIN
          h14000000 or d24 or                \ Set CTRMODE and APIN(dummy)
          ctra COG!                          \ PWM/NCO differential mode 
          i LED_level + C@                   \ Get level for target LED
          dT L@ u* 
          negate phsa COG!
          swap
          1msec waitcnt                      \ Wait until cnt+1msec
          swap
          0 ctra COG!                        \ Reset counter
     loop
\ 0 until
fkey? swap drop until
2drop
;

\ Display test pattern1 for LED_bar by using PWM/NCO differential mode
\ ( -- )
: demo4
LED_level scale    
3 0 do
     8 0 do 2dup i + C@ swap i + C! loop 
     swap 8 + swap
loop
2drop
LED_level d24 dump
c" pwm dif_drive_LED_bar" 0 cogx
begin fkey? swap drop until
0 cogreset                                                       
;



\ ************************************************
\   Using PWM/NCO single-ended mode by assembler  
\ ************************************************
lockdict create a_single_drive_LED_bar forthentry
$C_a_lxasm w, h13D  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi]mB l, z1SyLI[ l, z2Wi]uB l, z1SyLI[ l, z2Wia3B l, z1SyLI[ l, z2WyyG1 l, z2WiP[q l,
z2WyPb1 l, zfiPfp l, z1bixmD l, zfyPb1 l, z3[yP[T l, z2WixCt l, z20ixFk l, z2WiP[q l,
z2WiPfr l, z2WiPnp l, ziaBD l, z1Sy]fk l, z2[iQBG l, z2WiyZH l, z1biy3E l, z1biy4v l,
z3rixCt l, z2Wyy00 l, z20yPb1 l, z20yPj1 l, z3[yP[\ l, z1SV04Y l, z2WiPvs l, z2WyQ00 l,
z20iQ4u l, z3[yPvm l, z1SV000 l, 0 l, 0 l, 0 l, 0 l, zJY0 l,
zJY l, zG0000 l,
freedict

: demo5
LED_level scale    
3 0 do
     8 0 do 2dup i + C@ swap i + C! loop 
     swap 8 + swap
loop
2drop
LED_level d24 dump
c" LED_level d24 pwm a_single_drive_LED_bar" 0 cogx
begin fkey? swap drop until
0 cogreset
;





\ ************************************************
\   Using PWM/NCO differential mode by assembler  
\ ************************************************
lockdict create a_dif_drive_LED_bar forthentry
$C_a_lxasm w, h13E  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi]uB l, z1SyLI[ l, z2Wia3B l, z1SyLI[ l, z2WiaBB l, z2WyyG1 l, z2WiP[r l, z2WyPb1 l,
zfiPfq l, z1bixmD l, zfyPb1 l, z3[yP[S l, z2WixCu l, z20ixFk l, z2WiP[r l, z2WiPfs l,
z2WiPnq l, ziaJD l, z1Sy]nl l, z2[iQBG l, z2WiyZH l, z2WiPRE l, zfyPO9 l, z1biy3B l,
z1biy4w l, z3rixCu l, z2Wyy00 l, z20yPb1 l, z20yPj1 l, z3[yP[[ l, z1SV04X l, z2WiPvt l,
z2WyQ00 l, z20iQ4v l, z3[yPvn l, z1SV000 l, 0 l, 0 l, 0 l, 0 l,
zJY0 l, zJY l, zK000O l,
freedict
: demo6
LED_level scale    
3 0 do
     8 0 do 2dup i + C@ swap i + C! loop 
     swap 8 + swap
loop
2drop
LED_level d24 dump
c" LED_level d24 pwm a_dif_drive_LED_bar" 0 cogx
begin fkey? swap drop until
0 cogreset
;
















{
\ Assembler of drive_LED_bar  (single_ended mode)
\ ( n1 n2 n3 -- ) n1:address of LED_bar array   n2:number of leds   n3:first led

$C_treg1 - counter for lednum
$C_treg2 - index for LED_bar array
$C_treg3 - pin number
$C_treg4 - counter for multiple
$C_treg5 - result for multiple
$C_treg6 - $C_treg5's negative value 


fl                                                                          

[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]

build_BootOpt :rasm
     \ Get first_pin-number
     mov       __pin , $C_stTOS
     spop
     \ Get number of leds
     mov       __lednum , $C_stTOS
     spop
     \ Get address of LED_bar array
     mov       __array , $C_stTOS
     spop
     
     mov       frqa , # 1

     \ Set P(pwm)-P(pwm+23) to output
     mov       $C_treg1 , __lednum
     mov       $C_treg2 , # 1
     shl       $C_treg2 , __pin
__3
     or        dira , $C_treg2
     shl       $C_treg2 , # 1
     djnz      $C_treg1 , # __3     
   
     mov       cnt , __1msec
     add       cnt , cnt   
       
     \ initial
__1
     mov       $C_treg1 , __lednum 
     mov       $C_treg2 , __array 
     mov       $C_treg3 , __pin
     
     \ Load value from LED_level array and calculate and save it to phsa
__2 
     rdbyte    __bright , $C_treg2
     jmpret    __multi_ret , # __multi
     neg       $C_treg6 , $C_treg5
     mov       phsa , $C_treg6
  
     \ Save PWM/NCO single-ended mode to ctra
     or        ctra , $C_treg3
     or        ctra , __pwm     
     waitcnt   cnt , __1msec
     \ Reset ctra
     mov       ctra , # 0
     \ next pin
     add       $C_treg2 , # 1
     add       $C_treg3 , # 1     
     djnz      $C_treg1 , # __2          
     jmp       # __1

\ multiple __bright by __dT
__multi
     mov       $C_treg4 , __bright
     mov       $C_treg5 , # 0
__3
     add       $C_treg5 , __dT
     djnz      $C_treg4 , # __3
__multi_ret
ret
 

\ variables
__pin
0
__lednum
0  
__array
0
__bright
0

\ constants
__1msec
d80000
__dT
d1250
__pwm
h10000000

;asm a_single_drive_LED_bar

}

{
\ Assembler of drive_LED_bar  (differential mode)
\ ( n1 n2 n3 -- ) n1:address of LED_bar array   n2:number of leds   n3:first led

$C_treg1 - counter for lednum
$C_treg2 - index for LED_bar array
$C_treg3 - pin number
$C_treg4 - counter for multiple
$C_treg5 - result for multiple
$C_treg6 - $C_treg5's negative value 

fl                                                                          

[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]

build_BootOpt :rasm
     \ Get first_pin-number
     mov       __pin , $C_stTOS
     spop
     \ Get number of leds
     mov       __lednum , $C_stTOS
     spop
     \ Get address of LED_bar array
     mov       __array , $C_stTOS
\     spop
     
     mov       frqa , # 1

     \ Set P(pwm)-P(pwm+23) to output
     mov       $C_treg1 , __lednum
     mov       $C_treg2 , # 1
     shl       $C_treg2 , __pin
__3
     or        dira , $C_treg2
     shl       $C_treg2 , # 1
     djnz      $C_treg1 , # __3     
   
     mov       cnt , __1msec
     add       cnt , cnt   
       
     \ initial
__1
     mov       $C_treg1 , __lednum 
     mov       $C_treg2 , __array 
     mov       $C_treg3 , __pin
     
     \ Load value from LED_level array and calculate and save it to phsa
__2 
     rdbyte    __bright , $C_treg2
     jmpret    __multi_ret , # __multi
     neg       $C_treg6 , $C_treg5
     mov       phsa , $C_treg6
  
     \ Save PWM/NCO differential mode to ctra
     \ Using BPIN
     mov       $C_stTOS , $C_treg3
     shl       $C_stTOS , # 9
     or        ctra , $C_stTOS
     or        ctra , __pwm_dif
     waitcnt   cnt , __1msec
     \ Reset ctra
     mov       ctra , # 0
     \ next pin
     add       $C_treg2 , # 1
     add       $C_treg3 , # 1     
     djnz      $C_treg1 , # __2          
     jmp       # __1

\ multiple __bright by __dT
__multi
     mov       $C_treg4 , __bright
     mov       $C_treg5 , # 0
__3
     add       $C_treg5 , __dT
     djnz      $C_treg4 , # __3
__multi_ret
ret
 

\ variables
__pin
0
__lednum
0  
__array
0
__bright
0

\ constants
__1msec
d80000
__dT
d1250
__pwm_dif
h14000018

;asm a_dif_drive_LED_bar

}
