fl

{
LED_matrix     

PropForth 5.5 

 -- Curcuit --  
column                                           row
                   ------------------------       ------------
 P7   100ohm | 5 LED_p   LED_n_com 13 || Qa   RESET |--- 3.3V
 P6   100ohm | 2                    3 || Qb         |
 P5   100ohm | 7                    4 || Qc       A |--- P8
 P4   100ohm | 1                   10 || Qd    SCLK |--- P9
 P3   100ohm | 12                   6 |-| Qe    LCLK |--- P10
 P2   100ohm | 8                   11 || Qf         |
 P1   100ohm | 14                  15 || Qg      OE |--- GND
 P0   100ohm | 9                   16 || Qh         |
                   ------------------------       ------------
                          TOM-1588BH                74HC595

2013/10/22 20:39:42
}

\ a cog special register
[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]


\ *******************
\  Variables
\ *******************
variable dT
variable LED_matrix d60 allot
wvariable flag
wvariable flag1

\ *******************
\  Constants
\ *******************
0 constant pwm
1 pwm lshift constant pwmm
clkfreq d785 u/ constant 1.3msec             \ 1.273msec
                                             \ Rollover when "clkfreq d786 u/" on forth-word"drive_matrix"
clkfreq d10 u/ constant 10msec
clkfreq d20 u/ constant 50msec
clkfreq 5 u/ constant 200msec

8 constant data
9 constant sclk
d10 constant lclk
\ Brightness for LED_bar element
variable scale -4 allot 5 c, d10 c, d16 c, d23 c, d30 c, d37 c, d46 c, d64 c, 
d46 c, d37 c, d30 c, d23 c, d16 c, d10 c, 5 c,
scale 7 + constant scale_end
LED_matrix d64 + constant LED_matrix_end

\ =========================================================================== 
\ Set I/O 
\ =========================================================================== 
: data_l data pinlo ;
: data_h data pinhi ;
: sclk_l sclk pinlo ;
: sclk_h sclk pinhi ;
: lclk_l lclk pinlo ;
: lclk_h lclk pinhi ;

\ *******************
\  LED_matrix
\ *******************

\ Shift out 8bit-data to shift_register(74NC595)
\ ( n -- )  n:8bit data
: shift_data
1
8 0 do
     2dup and
     if
          data_h      
     else
          data_l      
     then
     sclk_h sclk_l
     1 lshift
loop
2drop
\ Set data to shift-register's output
lclk_h lclk_l
;

\ Initialize shift_register
\ ( -- )
: init_sr
\ Set ports to output 
data 3 0 do dup pinout 1+ loop drop
\ Set shift_register output to Hi
hFF shift_data  
;
                      
\ Drive LED-matrix 
\ Column by pwm  Row by dynamic-drive
\ ( -- ) n1:first pin of matrix_LED's column
: drive_matrix
init_sr
1.3msec d64 u/ dT L!

1 frqa COG!
\ Set P(pwm)-P(pwm+7) to output
pwm 8 0 do dup pinout 1+ loop drop

cnt COG@ 1.3msec +         
LED_matrix                              \ ( n1 n2 ) 
                                        \ n1:cnt  n2:address for LED_matrix
begin
     \ row
     8 0 do
          1 i lshift hFF xor shift_data           \ Drive LED-common siganal
          \ column
          8 0 do
               dup i +  C@                        \ Get level for matrix column
               dT L@ u* 
               negate phsa COG!
               pwm i + h10000000 or ctra COG!     \ PWM/NCO mode on LED pin     
               swap
               1.3msec waitcnt                    \ Wait until cnt+1.3msec
               swap
               0 ctra COG!                        \ Reset counter
          loop
          8 + dup LED_matrix_end = if drop LED_matrix then
     loop
          
\ 0 until                                                              
fkey? swap drop 
until
2drop
;

\ Display test pattern for LED_matrix by forth-word
\ ( -- )
: demo1
LED_matrix scale
8 0 do
     8 0 do 2dup C@ swap C! 1+ swap 1+ swap loop 8 -  \ Copy value to LED_matrix arry
loop
2drop
LED_matrix d64 dump

c" drive_matrix" 0 cogx
begin fkey? swap drop until
0 cogreset

\ drive_matrix                                                       
;





\ Shift out 8bit-data to shift_register(74NC595)
\ ( n1 n2  -- )  n1:8bit data  n2:output-port for shift-register
lockdict create a_shift_data forthentry
$C_a_lxasm w, h12C  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wy\01 l, zfi\3B l, z20yPO1 l, z2Wy\81 l, zfi\BB l, z20yPO1 l, z2Wy\G1 l, zfi\JB l,
z1SyLI[ l, z2Wi\RB l, z1SyLI[ l, z2WyPW8 l, zcy\O1 l, z1bfx[b l, z1[Zx[b l, z1bix[c l,
z1[ix[c l, z3[yP[V l, z1bix[d l, z1[ix[d l, z1SV01X l, 0 l, 0 l, 0 l,
0 l,
freedict

\ Assembler of driving LED_matrix  (single_ended mode)
\ ( n1 n2 -- ) n1:address of LED_matrix array    n2:first pin for LED_matrix
{
lockdict create a_drive_LED_matrix forthentry
$C_a_lxasm w, h135  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi\mB l, z1SyLI[ l, z2Wi]3B l, z1SyLI[ l, z2WyyG1 l, z2WixCl l, z20ixFk l, z2WyPW8 l,
z2WiPfj l, z2WiPnh l, zi]BD l, z1Sy\fc l, z2[iQBG l, z2WiyZH l, z1biy3E l, z1biy4n l,
z3rixCl l, z2Wyy00 l, z20yPb1 l, z20yPj1 l, z3[yP[T l, z1SV01X l, z2WiPvk l, z2WyQ00 l,
z20iQ4m l, z3[yPve l, z1SV000 l, 0 l, 0 l, 0 l, 0 l, z6G0 l,
z6G l, zG0000 l,
freedict
}
lockdict create a_drive_LED_matrix forthentry
$C_a_lxasm w, h134  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi\mB l, z1SyLI[ l, z2Wi\uB l, z1SyLI[ l, z2WyyG1 l, z2WixCk l, z20ixFk l, z2WyPW8 l,
z2WiPfi l, z2WiPnh l, zi]3D l, z1Sy\fc l, z2[iQBG l, z2WiyZH l, z1biy3E l, z1biy4m l,
z3rixCk l, z2Wyy00 l, z20yPb1 l, z20yPj1 l, z3[yP[T l, z1SV01X l, z2WiPvj l, z2WyQ00 l,
z20iQ4l l, z3[yPve l, z1SV000 l, 0 l, 0 l, 0 l, z6G0 l, z6G l,
zG0000 l,
freedict

\ Assembler-word of drive_matrix using counter mode(NCO/PWM single ended)
\ ( -- )
: a_drive_matrix
\ setup shift_register
init_sr

1 frqa COG!
\ Set P(pwm)-P(pwm+7) to output
pwm 8 0 do dup pinout 1+ loop drop

LED_matrix                              \ ( n1 n2 ) 
                                        \ n1:cnt  n2:address for LED_matrix
begin
     \ row
     8 0 do                     
          1 i lshift hFF xor data a_shift_data           \ Drive LED-common siganal
          \ column                    
          dup pwm a_drive_LED_matrix
          \ Next address for LED_matrix array
          8 + dup LED_matrix_end = if drop LED_matrix then
     loop          
\ 0 until                                                              
fkey? swap drop 
until
drop
;

\ Display pattern on LED_matrix
\ ( -- )
: demo2
LED_matrix scale
8 0 do
     8 0 do 2dup C@ swap C! 1+ swap 1+ swap loop 8 -  \ Copy value to LED_matrix arry
loop
2drop
LED_matrix d64 dump     
c" a_drive_matrix" 0 cogx       
begin fkey? swap drop until
0 cogreset                                                       
;
    
\ Display moving pattern1
\ ( -- )
: demo3
c" a_drive_matrix" 0 cogx 
cnt COG@ 10msec +      
begin 
     LED_matrix scale 
     8 0 do
          2dup
          \ Copy data to 8row       
          8 0 do
               \ Copy data to 1row( 8 LED)
               8 0 do 
                    2dup C@ swap C!          \ Copy data to LED_matrix array
                    1+ swap 1+ swap          \ Increment address of LED_matrix and scale 
               loop 
               8 -                           \ Subtract 8 from scale address        
          loop
          2drop
          1+                                 \ Increment scale address
          rot
          10msec waitcnt                     \ Wait until cnt+1msec
          rot2
     loop
     2drop
     fkey? swap drop 
until
0 cogreset 
drop                                                      
;


\ Display moving pattern2
\ ( -- )
: demo4
c" a_drive_matrix" 0 cogx 

\ Set flag to increment
\ flag is used to increment or decrement scale_address 
1 flag W!
cnt COG@ 200msec +   
LED_matrix scale    
begin 
          \ Copy data to 8row       
          8 0 do
               \ Copy data to 1row( 8 LED)
               8 0 do 
                    flag W@ 
                    if 
                         \ scale_end?
                         dup scale_end = if 0 flag W! then
                    else 
                         \ scale?
                         dup scale = if 1 flag W! then
                    then
                    2dup C@ swap C!                    \ Copy data to LED_matrix array
                    flag W@ 
                    if 1+ else 1- then swap 1+ swap    \ Increment or decremant scale_address
                    
               loop 
          loop
                              LED_matrix d64 dump
          nip LED_matrix  swap
          rot
          200msec waitcnt                              \ Wait until cnt+200msec
          rot2
   
     fkey? swap drop 
until
0 cogreset 
3drop                                                      
;

\ Display moving pattern3
\ ( -- )
: demo5
c" a_drive_matrix" 0 cogx
\ Set flag to increment
\ flag is used to increment or decrement scale_address 
1 flag W! 

cnt COG@ 50msec +   
LED_matrix scale    
begin 
          2dup              
          \ Copy data to 8row       
          8 0 do
               \ Copy data to 1row( 8 LED)               
               flag W@ flag1 W!                        \ Copy flag to flag1
                                                       \ flag1 is used to increment or decrement scale_address inside 1-row
               8 0 do 
                    2dup C@ swap C!                    \ Copy data to LED_matrix array
                    flag1 W@ 
                    if              
                         \ scale_end?
                         dup scale_end = if 0 flag1 W! then 
                    else 
                         \ scale?
                         dup scale = if 1 flag1 W! then
                    then
                    flag1 W@ 
                    if 1+ else 1- then                 \ Increment or decremant scale_address 
                    swap 1+ swap                       \ Increment LED_matrix address     
               loop 
               drop over                               \ Back scale_address to initial
          loop
               2drop
               flag W@ 
               if 
                    \ scale_end?
                    dup scale_end = if 0 flag W! then
               else 
                    \ scale?
                    dup scale = if 1 flag W! then
               then
               flag W@ 
               if 1+ else 1- then                      \ Increment or decremant scale_address 
\                        LED_matrix d64 dump
          rot
          50msec waitcnt                               \ Wait until cnt+50msec
          rot2   
     fkey? swap drop 
until
0 cogreset 
3drop                                                      
;








lockdict create a_pwm forthentry
$C_a_lxasm w, h12F  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi\JB l, z1SyLI[ l, z2Wi\RB l, z1SyLI[ l, z2WixCg l, z20ixFk l, z2Wi\[h l, z2WiP[e l,
z2WyPb0 l, z2WyPj8 l, ziPuC l, z20yPr1 l, zfyPb1 l, z27F\ZF l, z1bxPb1 l, z20yPW1 l,
z3[yPnT l, zfiPfd l, z3rixCg l, z2WixZD l, z3[y\[Q l, z2WyxW0 l, z1SV01X l, 0 l,
0 l, 0 l, z6G l, z10 l,
freedict

\ Assembler-word using TS
\ ( -- )
: a_pwm_matrix
\ setup shift_register
init_sr

\ Set P(pwm)-P(pwm+7) to output
pwm 8 0 do dup pinout 1+ loop drop

LED_matrix                              \ ( n1 n2 ) 
                                        \ n1:cnt  n2:address for LED_matrix
begin
     \ row
     8 0 do                     
          1 i lshift hFF xor data a_shift_data           \ Drive LED-common siganal
          \ column     
          dup pwm a_pwm
          \ Next address for LED_matrix array
          8 + dup LED_matrix_end = if drop LED_matrix then
     loop          
\ 0 until                                                              
fkey? swap drop 
until
drop
;

\ Display moving pattern4 using no counter
\ ( -- )
: demo6
LED_matrix scale
8 0 do
     8 0 do 2dup C@ swap C! 1+ swap 1+ swap loop 8 -  \ Copy value to LED_matrix arry
loop
2drop
LED_matrix d64 dump     

c" a_pwm_matrix" 0 cogx       
begin fkey? swap drop until
0 cogreset                                                       
;









{

\ ****************************************************************************
\ Shift out 8bit-data to shift_register(74NC595)
\ ( n1 n2  -- )  n1:8bit data  n2:output-port for shift-register
\ ****************************************************************************
$C_streg1 - counter

fl                                                                          
build_BootOpt :rasm
     \ Get serial-in_data mask
     mov       __si , # 1
     shl       __si , $C_stTOS
     \ Get sclk mask
     add       $C_stTOS , # 1
     mov       __sclk , # 1
     shl       __sclk , $C_stTOS
     \ Get lclk mask
     add       $C_stTOS , # 1
     mov       __lclk , # 1
     shl       __lclk , $C_stTOS
     spop
     
     \ get data
     mov       __data , $C_stTOS
     spop
     
     \ Send data by serial, first bit0
     mov       $C_treg1 , # 8
__1
     shr       __data , # 1 wc
     \ Set si to Hi
if_c      or        outa , __si
     \ Set si to Lo
if_nc     andn      outa , __si
     \ Output clk
     or        outa , __sclk 
     andn      outa , __sclk 
     djnz      $C_treg1 , # __1
     
     \ Output lclk
     or        outa , __lclk 
     andn      outa , __lclk 
     
     jexit
     
__si
0
__sclk
0
__lclk
0
__data
0
     
;asm a_shift_data
          


\ ****************************************************************************
\ Assembler of LED_matrix  (single_ended mode)
\ ( n1 n2 -- ) n1:address of LED_matrix array    n2:first pin for LED_matrix
\ ****************************************************************************

$C_treg1 - counter for column of LED_matrix
$C_treg2 - index for LED_matrix array
$C_treg3 - pin number
$C_treg4 - counter for multiple
$C_treg5 - result for multiple
$C_treg6 - $C_treg5's negative value 


fl                                                                          

[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]

build_BootOpt :rasm
     \ Get first_pin-number
     mov       __pin , $C_stTOS
     spop
     \ Get address of LED_bar array
     mov       __array , $C_stTOS
     spop
     
     mov       frqa , # 1

     mov       cnt , __320usec
     add       cnt , cnt   
       
     \ initial
__1
     mov       $C_treg1 , # 8 
     mov       $C_treg2 , __array 
     mov       $C_treg3 , __pin
     
     \ Load value from LED_matrix array and calculate and save it to phsa
__2 
     rdbyte    __bright , $C_treg2
     jmpret    __multi_ret , # __multi
     neg       $C_treg6 , $C_treg5
     mov       phsa , $C_treg6
  
     \ Save PWM/NCO single-ended mode to ctra
     or        ctra , $C_treg3
     or        ctra , __pwm     
     waitcnt   cnt , __320usec
     \ Reset ctra
     mov       ctra , # 0
     \ next pin
     add       $C_treg2 , # 1
     add       $C_treg3 , # 1     
     djnz      $C_treg1 , # __2          
     jexit

\ multiple __bright by __dT
__multi
     mov       $C_treg4 , __bright
     mov       $C_treg5 , # 0
__3
     add       $C_treg5 , __dT
     djnz      $C_treg4 , # __3
__multi_ret
ret
 

\ variables
__pin
0
__array
0
__bright
0

\ constants
__320usec
d25600
\ dT = 250usec/d64
__dT
d400
__pwm
h10000000

;asm a_drive_LED_matrix



\ ****************************************************************************
\ PWM by using TS(TimeSlot) 
\ ( n1 n2  -- )  n1:address of LED_matrix array  n2:first pin for LED_matrix
\ ****************************************************************************
$C_streg1 - index for LED_matrix array
$C_streg2 - 
$C_streg3 - counter for column of LED_matrix
$$C_treg4 - content of LED_matrix array

fl
build_BootOpt :rasm
     \ Get first_pin-number
     mov       __pin , $C_stTOS
     spop
     \ Get address of LED_bar array
     mov       __array , $C_stTOS
     spop
     
     mov       cnt , __TS
     add       cnt , cnt   
     \ Set bright to max level
     mov       __bright , __bright_max
__1     
     mov       $C_treg1 , __array           
     mov       $C_treg2 , # 0
     \ element number for matrix
     mov       $C_treg3 , # 8
__2
     \ Load data from LED_matrix array
     rdbyte    $C_treg4 , $C_treg1
     \ Add 1 to $C_treg4 because all bit are 0 at first TS.
     add       $C_treg4 , # 1
     shl       $C_treg2 , # 1
     \ if __bright = $C_treg4, z-flag is 1
     \ if __bright < $C_treg4, c-flag is 1
     cmp       __bright , $C_treg4 wc wz
if_c_or_z or   $C_treg2 , # 1
     add       $C_treg1 , # 1
     djnz      $C_treg3 , # __2
     
     shl       $C_treg2 , __pin
     waitcnt   cnt , __TS     
     mov       outa , $C_treg2       
     djnz      __bright , # __1
     \ Clear outa
     mov       outa , # 0
     
     jexit

\ variables
__pin
0
__array
0
__bright
0

\ constants
__TS
d400
__bright_max
d64

;asm a_pwm

}
