fl

{
single_LED    

PropForth 5.5 

-- Curcuit for demo1 and demo2/demo3 --    
 P0  220ohm LED_n LED_p  3.3V

-- Curcuit for demo4 --    
 P0  220ohm LED_n LED_p  3.3V
 P1  220ohm LED_n LED_p  3.3V

2013/10/19 20:06:25
}



\ a cog special register
[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]


\ *******************
\  Constants
\ *******************
0 constant pwm
pwm >m constant pwmm
clkfreq d10000 u/ constant 100usec

\ *******************
\  Variables
\ *******************
variable dT
variable cycle
wvariable flag

\ *******************
\   main
\ *******************

\ Blinking LED
\ pwm output  Cycle=1second On-time=875msec Off-time=125msec 
\ ( -- )
: demo1
clkfreq 8 u/ dT L!                 \ dT=125msec
h10000000 pwm or ctra COG!         \ Set mode to "NCO/PWM single-ended"
1 frqa COG!
dira COG@ pwmm or dira COG!         \ Set pwm to output

cnt COG@ clkfreq +                 \ cnt +1second
begin
     dT L@ negate phsa COG!        \ Set -dT to phsa
     clkfreq waitcnt               \ Wait until isec pass
     fkey? swap drop               \ Stop if any key
until
drop
0 ctra COG!                        \ Reset counter
dira COG@ pwmm andn dira COG!      \ Set pwm to input 
;     

\ Changing On-time for LED from 100% to 0% [1second]
\ ( -- )
: demo2
clkfreq d100 u/ dT L!              \ cycle time=10msec
h10000000 pwm or ctra COG!         \ Set mode to "NCO/PWM single-ended"
1 frqa COG!
dira COG@ pwmm or dira COG!        \ Set pwm to output

cnt COG@ dT L@ +                   \ cnt + 10msec
0
begin
     dup negate phsa COG!          \ Set -value to phsa
     swap
     dT L@ waitcnt                 \ Wait until 10msec pass
     swap
     100usec +                     \ Add ticks(100usec)
     dup dT L@ > if drop 0 then
     fkey? swap drop               \ Stop if any key
until
2drop
0 ctra COG!
dira COG@ pwmm andn dira COG!      \ Set pwm to input 
;

\ Changing On-time for LED from 100% to 0% and 0% to 100% [2second]
\ ( -- )
: demo3
clkfreq d100 u/ dT L!              \ cycle time=10msec
h10000000 pwm or ctra COG!         \ Set mode to "NCO/PWM single-ended"
1 frqa COG!
dira COG@ pwmm or dira COG!        \ Set pwm to output

cnt COG@ dT L@ +                   \ cnt + 10msec
0
begin
     dup negate phsa COG!          \ Set -value to phsa
     swap
     dT L@ waitcnt                 \ Wait until 10msec pass
     swap
     100usec 
     flag W@                       \ Check if incremnt or decrement for Hi-term
     if - else + then              \ Subtract 100usec if flag=1    
     dup dT L@ > 
     if 
          1 flag W! 100usec - 
     else
          dup 0<                   \ Check if minus
          if drop 0 0 flag W! then \ 
     then
     fkey? swap drop               \ Stop if any key
until
2drop
0 ctra COG!
dira COG@ pwmm andn dira COG!      \ Set pwm to input 
;

\ Changing On-time for LED from 100% to 0% and 0% to 100% [2second]
\ Almost same as demo3 by using NCO/PWM differential mode
\ APIN:P0  BPIN:P1
\ ( -- )
: demo4
clkfreq d100 u/ dT L!              \ cycle time=10msec
pwm pwm 1+ 9 lshift or             \ APIN + BPIN
h14000000 or ctra COG!             \ Set mode to "NCO/PWM differential"
1 frqa COG!
dira COG@ pwmm or dira COG!        \ Set pwm to output
dira COG@ pwmm 1+  or dira COG!    \ Set pwm to output
cnt COG@ dT L@ +                   \ cnt + 10msec
0
begin
     dup negate phsa COG!          \ Set -value to phsa
     swap
     dT L@ waitcnt                 \ Wait until 10msec pass
     swap
     100usec 
     flag W@                       \ Check if incremnt or decrement for Hi-term
     if - else + then              \ Subtract 100usec if flag=1    
     dup dT L@ > 
     if 
          1 flag W! 100usec - 
     else
          dup 0<                   \ Check if minus
          if drop 0 0 flag W! then \ 
     then
     fkey? swap drop               \ Stop if any key
until
2drop
ctra COG@ hex .   dira COG@ .
0 ctra COG!
dira COG@ pwmm andn dira COG!      \ Set pwm to input 
;

