fl

{
LED_sensor     

PropForth 5.5 

    
 P0  220ohm LED  P1
 ledp                     ledn

2013/10/05 23:17:11
}

\ a cog special register
[ifndef ctra
h1F8	wconstant ctra 
]

[ifndef frqa
h1FA	wconstant frqa
]

[ifndef phsa
h1FC	wconstant phsa
]


\ *******************
\  Constants
\ *******************
0 constant ledp
1 constant ledn
1 ledp lshift constant ledpm
1 ledn lshift constant lednm
lednm ledpm or constant ledm

\ *******************
\  main
\ *******************
{
\ Time delay for using forth word
: time cnt COG@ cnt COG@ swap - . ;                 \ 272
: 5.6usec cnt COG@ 1 3 drop drop cnt COG@ swap - d272 - . ;    \ 448
}

\ Read_phsa (ticks during Hi-pulse on P1)
\ After adding revaerse bias, measuring Hi-time of N-side for LED 
\ ( -- n1)  n1:phsa value
: readLED
\ Reverse bias for LED
outa COG@ 
ledpm andn lednm or outa COG!      \ Set outa for ledp=0 ledn=1
dira COG@ ledm or dira COG!        \ Set ledn and ledp to output
1 3 drop drop                      \ Wait 5.6usec
0 phsa COG!
dira COG@ lednm andn dira COG!     \ Set ledn to input

\ Wait until ledn become to Lo
begin 
     ina COG@ lednm and            \ Get lednm
     phsa COG@ d800000 >           \ Time out 10msec
     if drop 1 else 0= then 
until  
phsa COG@
;

\ Print out phsa value 
\ ( -- )
: test 
h20000000 ledn or ctra COG!        \ Set mode to "POS detector"
1 frqa COG!

clkfreq 5 u/ cnt COG@ +            \ loop time 200msec
begin      
     readLED    . cr      
     clkfreq 5 u/ waitcnt     
     fkey? swap drop 
until 
drop
;

\ Print out phsa value as '*' on TeraTerm
\ ( -- )
: test1 
h20000000 ledn or ctra COG!             \ Set mode to "POS detector"
1 frqa COG!

clkfreq  cnt COG@ +                     \ loop time 1sec
begin      
     readLED   \ .       
     d10000 u/ 0 do h2A emit loop cr
     clkfreq  waitcnt                   \ loop time 1sec
     fkey? swap drop 
until 
drop
;

\ LED_sensor demo
\ LED on at dark, LED off at light
\ ( -- )
: demo1
h20000000 ledn or ctra COG!             \ Set mode to "POS detector"
1 frqa COG!

clkfreq 5 u/ cnt COG@ +                 \ loop time 200msec
begin
     readLED         \     dup .  
     dira COG@ lednm andn dira COG!     \ Set ledn to output
     cnt COG@ cnt COG@ drop drop
     
     \ On LED if  d400000     
     d400000 >                          \ Compare threshold level
     if 
                    \    ." LED on"  cr
          outa COG@  
          lednm andn ledpm or outa COG! \ Set outa for ledp=1 ledn=0
          dira COG@ ledm or dira COG!   \ Set ledn and ledp to output
     then
     clkfreq 5 u/ waitcnt               \ loop time 200msec
     
     fkey? swap drop
until
drop
;
